searchNodes=[{"type":"module","title":"Phx.Live.Head","doc":"Provides commands for manipulating the HTML Head of Phoenix Live View applications while minimizing data over the wire. The available command actions support a variety of utility operations useful for HTML Head manipulation. Such as setting or removing tag attributes and adding or removing CSS classes for vector (SVG) favicons. Note This lib is not meant to be used directly. Have a look at Phx.Live.Favicon and Phx.Live.Metadata . Those libs provide a cleaner syntax and specific documentation for their intended usage. Query The query is used by the the Javascript client to select HTML elements using document.querySelectorAll(query) . Actions Nodes / Elements snap - Takes a snapshot of all selected nodes. restore - Restores a saved snapshot. dynamic - Set the value of a {placeholder} . Attributes The actions are applied to an attribute in all selected HTML elements. Supported actions on the &quot;class&quot; attribute: set - Set class name(s). add - Add to list of class names. remove - Remove from list of class names. toggle - Toggle class name. initial - Reset attribute to it's intial value. Supported actions on other attributes: set - Set value of attribute. initial - Reset attribute to it's intial value. snap - Take a snapshot of all selected nodes. restore - Restore attributes using a saved snapshot Dynamic attributes / placeholders To use a dynamic value for an attribute, the element must have an additional data-dynamic-[attribute] attribute with a value containing a named placeholder. For example: {sub} . Example &lt;!-- data-dynamic-href is set --&gt; &lt;!-- {sub} is used in it's value --&gt; &lt;link rel='icon' href=&quot;default_fav.png&quot; data-dynamic-href=&quot;favs/{sub}/fav-16x16.png&quot;&gt; When an event is pushed with target = &quot;link[rel*=icon]&quot; , action = :dynamic , attr = &quot;sub&quot; , and value = &quot;new_message&quot; the result will look like: &lt;link rel='icon' href=&quot;favs/new_message/fav-16x16.png&quot; [...]&gt;","ref":"Phx.Live.Head.html"},{"type":"function","title":"Phx.Live.Head.push/5","doc":"Pushes action to apply on attribute of elements matching query . See Actions for available actions.","ref":"Phx.Live.Head.html#push/5"},{"type":"function","title":"Phx.Live.Head.push_content/4","doc":"Pushes action to apply on textContent property of elements matching query . Comments Why textContent and not innerHTML ? As per MDN web docs, Node: textContent property , &quot;...there is still a security risk whenever you use innerHTML to set strings over which you have no control. ... For that reason, it is recommended that instead of innerHTML you use ... Node.textContent when inserting plain text, as this inserts it as raw text rather than parsing it as HTML.&quot;","ref":"Phx.Live.Head.html#push_content/4"},{"type":"function","title":"Phx.Live.Head.reset/2","doc":"Reset all attributes of elements matching query to their initial value.","ref":"Phx.Live.Head.html#reset/2"},{"type":"function","title":"Phx.Live.Head.reset/3","doc":"Reset an attribute of elements matching query to it's initial value.","ref":"Phx.Live.Head.html#reset/3"},{"type":"function","title":"Phx.Live.Head.restore/4","doc":"Restore an attribute from snapshot with named name .","ref":"Phx.Live.Head.html#restore/4"},{"type":"function","title":"Phx.Live.Head.snap/4","doc":"Create a snapshot named name of an attribute from all favicon link element","ref":"Phx.Live.Head.html#snap/4"},{"type":"type","title":"Phx.Live.Head.action/0","doc":"","ref":"Phx.Live.Head.html#t:action/0"},{"type":"type","title":"Phx.Live.Head.attr/0","doc":"","ref":"Phx.Live.Head.html#t:attr/0"},{"type":"type","title":"Phx.Live.Head.change/0","doc":"","ref":"Phx.Live.Head.html#t:change/0"},{"type":"type","title":"Phx.Live.Head.name/0","doc":"","ref":"Phx.Live.Head.html#t:name/0"},{"type":"type","title":"Phx.Live.Head.query/0","doc":"","ref":"Phx.Live.Head.html#t:query/0"},{"type":"type","title":"Phx.Live.Head.value/0","doc":"","ref":"Phx.Live.Head.html#t:value/0"},{"type":"extras","title":"README","doc":"Phoenix Live Head Provides commands for manipulating the HTML Head of Phoenix Live View applications while minimizing data over the wire. The available command actions support a variety of utility operations useful for HTML Head manipulation. Such as setting or removing tag attributes and adding or removing CSS classes. Note When using this lib directly, consider publishing a high-level lib like Phx.Live.Favicon . High-level libs provide a cleaner syntax and specific documentation for their intended usage.","ref":"readme.html"},{"type":"extras","title":"README - Documentation","doc":"Documentation can be found at HexDocs .","ref":"readme.html#documentation"},{"type":"extras","title":"README - Support, Feature Requests and Contributing","doc":"See CONTRIBUTING","ref":"readme.html#support-feature-requests-and-contributing"},{"type":"extras","title":"README - Installation","doc":"The package can be installed by adding phoenix_live_head to your list of dependencies in mix.exs : def deps do [ { :phoenix_live_head , &quot;~&gt; 0.2.0&quot; } ] end To include the necessary client side Javascript, import the module in assets/js/app.js import &quot;phoenix_html&quot; // Establish Phoenix Socket and LiveView configuration. import { Socket } from &quot;phoenix&quot; import { LiveSocket } from &quot;../vendor/phoenix_live_view/&quot; import topbar from &quot;../vendor/topbar&quot; import &quot;phoenix_live_head&quot; // &lt;-- ADD HERE.","ref":"readme.html#installation"},{"type":"extras","title":"README - Development","doc":"Assets can be build using mix assets.build Override :phoenix_live_head in your test application with a local path: # example def deps do [ { :phoenix_live_head , path : &quot;../phoenix_live_head&quot; , override : true } ] end","ref":"readme.html#development"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - v0.3","doc":"feat: new function push_content; making a call to update the textContent property and not an attribute. (#16). Contributed by @sachamasry","ref":"changelog.html#v0-3"},{"type":"extras","title":"Changelog - v0.2.2","doc":"This release has been made possible by @dfalling; again not only reporting the issue but also fixing it. fix: add new put_event for liveview 0.20 (#12)","ref":"changelog.html#v0-2-2"},{"type":"extras","title":"Changelog - v0.2.1","doc":"This release has been made possible by @dfalling; not only reporting issues but also fixing them. Thanks! fix: update private changed for liveview 0.19.0 fix: do not force redraw as it causes flickers (#10)","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"Changelog - v0.2.0","doc":"Features Create and restore snapshots Store the result of multiple operations under a chosen name and restore it at a later time using snap and restore . snap - Takes a snapshot of all attribute values. restore - Applies a snapshot to selected elements. Usage example In the Live Favicon Example application it is used to send all changes required to switch between an dynamic SVG counter and static PNG message-icon once, and toggle the state between them; creating a flashing notification. As it also makes a snapshot of the state before the favicon begins to flash, the icon on the page can be restored to it's value as soon as the user read the unread messages. Use multiple placeholders You can now use multiple custom named placeholders, instead of only one {dynamic} per attribute. &lt;link [...] data-dynamic-href=&quot;data:image/svg+xml, &lt;svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 100 100'&gt; &lt;circle cx='50' cy='50' r='50' fill='{counter_background}' /&gt; &lt;text x='50%' y='50%' [...]&gt; {counter} &lt;/text&gt; &lt;/svg&gt; &quot; &gt; Fixes Unstable order of change execution when using multiple queries / libs. BREAKING the attribute value of dynamic is now used as name for the target placeholder. As a result, it is not possible anymore to target a specific attribute. Migration is as easy as using different names per attribute when necessary.","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"Changelog - v0.1.2","doc":"Discards previous changes put in events for given element or attribute when using reset . Fix: preserve event order Fix: predictable behavior when using reset/1 or reset/2 . Fix: undefined class name after reset","ref":"changelog.html#v0-1-2"},{"type":"extras","title":"Changelog - v0.1.1","doc":"Fix: Loosen dependency versions","ref":"changelog.html#v0-1-1"},{"type":"extras","title":"Changelog - v0.1.0","doc":"Release","ref":"changelog.html#v0-1-0"},{"type":"extras","title":"Changelog - v0.0.1","doc":"Initial commit","ref":"changelog.html#v0-0-1"},{"type":"extras","title":"Contributing","doc":"Please take a moment to review this document in order to make the contribution process easy and effective for everyone involved!","ref":"contributing.html"},{"type":"extras","title":"Contributing - Using the issue tracker","doc":"Use the issues tracker for: Bug reports Submitting pull requests Please do not use the issue tracker for personal support requests nor feature requests. Feature and support requests should be created on the Elixir forum and be tagged with at least phoenix_live_head Support Request Feature Request We do our best to keep the issue tracker tidy and organized, making it useful for everyone. For example, we classify open issues per perceived difficulty, making it easier for developers to contribute to Phoenix Live Head .","ref":"contributing.html#using-the-issue-tracker"},{"type":"extras","title":"Contributing - Bug reports","doc":"A bug is either a demonstrable problem that is caused by the code in the repository, or indicate missing, unclear, or misleading documentation. Good bug reports are extremely helpful - thank you! Guidelines for bug reports: Use the GitHub issue search &amp;mdash; check if the issue has already been reported. Check if the issue has been fixed &amp;mdash; try to reproduce it using the main branch in the repository. Isolate and report the problem &amp;mdash; ideally create a reduced test case. Please try to be as detailed as possible in your report. Include information about your Erlang, Elixir, Phoenix and Phoenix LiveView versions. Please provide steps to reproduce the issue as well as the outcome you were expecting! All these details will help developers to fix any potential bugs. Example: Short and descriptive example bug report title A summary of the issue and the environment in which it occurs. If suitable, include the steps required to reproduce the bug. This is the first step This is the second step Further steps, etc. &lt;url&gt; - a link to the reduced test case (e.g. a GitHub Gist) Any other information you want to share that is relevant to the issue being reported. This might include the lines of code that you have identified as causing the bug, and potential solutions (and your opinions on their merits).","ref":"contributing.html#bug-reports"},{"type":"extras","title":"Contributing - Feature requests","doc":"Feature requests are welcome and should be discussed on the Phoenix Live Head topic on the Elixir forum . But take a moment to find out whether your idea fits with the scope and aims of the project. It's up to you to make a strong case to convince the community of the merits of this feature. Please provide as much detail and context as possible.","ref":"contributing.html#feature-requests"},{"type":"extras","title":"Contributing - Pull requests","doc":"Good pull requests - patches, improvements, new features - are a fantastic help. They should remain focused in scope and avoid containing unrelated commits. IMPORTANT : By submitting a patch, you agree that your work will be licensed under the license used by the project. If you have any large pull request in mind (e.g. implementing features, refactoring code, etc), please ask first otherwise you risk spending a lot of time working on something that the project's developers might not want to merge into the project. Please adhere to the coding conventions in the project (indentation, accurate comments, etc.) and don't forget to add your own tests and documentation. When working with git, we recommend the following process in order to craft an excellent pull request: Fork the project, clone your fork, and configure the remotes: # Clone your fork of the repo into the current directory git clone https://github.com/&lt;your-username&gt;/phoenix_live_head # Navigate to the newly cloned directory cd phoenix # Assign the original repo to a remote called &quot;upstream&quot; git remote add upstream https://github.com/BartOtten/phoenix_live_head If you cloned a while ago, get the latest changes from upstream, and update your fork: git checkout main git pull upstream main git push Create a new topic branch (off of main ) to contain your feature, change, or fix. IMPORTANT : Making changes in main is discouraged. You should always keep your local main in sync with upstream main and make your changes in topic branches. git checkout -b &lt;topic-branch-name&gt; Commit your changes in logical chunks. Keep your commit messages organized, with a short description in the first line and more detailed information on the following lines. Feel free to use Git's interactive rebase feature to tidy up your commits before making them public. Make sure all the tests are still passing. mix test Push your topic branch up to your fork: git push origin &lt;topic-branch-name&gt; Open a Pull Request with a clear title and description. If you haven't updated your pull request for a while, you should consider rebasing on main and resolving any conflicts. IMPORTANT : Never ever merge upstream main into your branches. You should always git rebase on main to bring your changes up to date when necessary. git checkout main git pull upstream main git checkout &lt;your-topic-branch&gt; git rebase main Thank you for your contributions!","ref":"contributing.html#pull-requests"},{"type":"extras","title":"Contributing - Guides","doc":"These Guides aim to be inclusive. We use &quot;we&quot; and &quot;our&quot; instead of &quot;you&quot; and &quot;your&quot; to foster this sense of inclusion. Ideally there is something for everybody in each guide, from beginner to expert. This is hard, maybe impossible. When we need to compromise, we do so on behalf of beginning users because expert users have more tools at their disposal to help themselves. The general pattern we use for presenting information is to first introduce a small, discrete topic, then write a small amount of code to demonstrate the concept, then verify that the code worked. In this way, we build from small, easily digestible concepts into more complex ones. The shorter this cycle is, as long as the information is still clear and complete, the better. For formatting the guides: We use the &quot;elixir&quot; code fence for all module code. We use the &quot;console&quot; code fence for iex and shell commands. We use the &quot;html&quot; code fence for html templates, even if there is elixir code in the template. We use backticks for filenames and directory paths. We use backticks for module names, function names, and variable names.","ref":"contributing.html#guides"},{"type":"extras","title":"License","doc":"Copyright (c) 2022 Bart Otten Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}]